#ifndef EFL_UI_FOCUS_USER_EO_HH
#define EFL_UI_FOCUS_USER_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_focus_manager.eo.h"
#include "efl_ui_focus_object.eo.h"
#include "efl_ui_focus_user.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_ui_focus_manager.eo.hh"
#include "efl_ui_focus_object.eo.hh"
namespace efl { namespace ui { namespace focus { 
struct User;
} } } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::focus::User> : ::std::true_type {}; } }
namespace efl { namespace ui { namespace focus { 
struct User;
} } } 
namespace efl { namespace ui { namespace focus { 
struct Manager;
} } } 
namespace efl { namespace ui { namespace focus { 
struct Object;
} } } 

namespace eo_cxx {
namespace efl { namespace ui { namespace focus { 
struct User {
   ::efl::eolian::return_traits< ::efl::ui::focus::Manager>::type manager_get() const;
   ::efl::eolian::return_traits< ::efl::ui::focus::Object>::type parent_get() const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_FOCUS_USER_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::ui::focus::User() const;
   operator ::efl::ui::focus::User&();
   operator ::efl::ui::focus::User const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<User> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<User const > operator&() const { return {this}; }
   /// @endcond
};
} } } 
}
namespace efl { namespace ui { namespace focus { 
struct User : ::efl::eo::concrete
{
   explicit User( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit User(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   User(User const& other) = default;
   User(User&& other) = default;
   User& operator=(User const& other) = default;
   User& operator=(User&& other) = default;
   User()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   User( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> User(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< ::efl::ui::focus::Manager>::type manager_get() const;
   ::efl::eolian::return_traits< ::efl::ui::focus::Object>::type parent_get() const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_FOCUS_USER_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct manager_changed_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_FOCUS_USER_EVENT_MANAGER_CHANGED; }
      typedef  ::efl::ui::focus::Manager parameter_type;
   } const manager_changed_event;
   static struct logical_changed_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_FOCUS_USER_EVENT_LOGICAL_CHANGED; }
      typedef  ::efl::ui::focus::Object parameter_type;
   } const logical_changed_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<User> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<User const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(User) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<User>::value, "");
} } } 
#endif
